// license:BSD-3-Clause
// copyright-holders:Olivier Galibert

#include "emu.h"
#include "emumem_hedr.ipp"


template class handler_entry_read_dispatch< 1, 0,  1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 1, 0,  1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 2, 0,  1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 2, 0,  1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 3, 0,  1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 3, 0,  1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 4, 0,  1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 4, 0,  1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 5, 0,  1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 5, 0,  1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 6, 0,  1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 6, 0,  1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 7, 0,  1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 7, 0,  1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 8, 0,  1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 8, 0,  1, ENDIANNESS_BIG>;

template class handler_entry_read_dispatch< 1, 0,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 1, 0,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 2, 0,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 2, 0,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 3, 0,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 3, 0,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 4, 0,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 4, 0,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 5, 0,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 5, 0,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 6, 0,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 6, 0,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 7, 0,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 7, 0,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 8, 0,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 8, 0,  0, ENDIANNESS_BIG>;

template class handler_entry_read_dispatch< 1, 1,  3, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 1, 1,  3, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 2, 1,  3, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 2, 1,  3, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 3, 1,  3, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 3, 1,  3, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 4, 1,  3, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 4, 1,  3, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 5, 1,  3, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 5, 1,  3, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 6, 1,  3, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 6, 1,  3, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 7, 1,  3, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 7, 1,  3, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 8, 1,  3, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 8, 1,  3, ENDIANNESS_BIG>;

template class handler_entry_read_dispatch< 1, 1,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 1, 1,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 2, 1,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 2, 1,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 3, 1,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 3, 1,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 4, 1,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 4, 1,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 5, 1,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 5, 1,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 6, 1,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 6, 1,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 7, 1,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 7, 1,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 8, 1,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 8, 1,  0, ENDIANNESS_BIG>;

template class handler_entry_read_dispatch< 1, 1, -1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 1, 1, -1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 2, 1, -1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 2, 1, -1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 3, 1, -1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 3, 1, -1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 4, 1, -1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 4, 1, -1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 5, 1, -1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 5, 1, -1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 6, 1, -1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 6, 1, -1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 7, 1, -1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 7, 1, -1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 8, 1, -1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 8, 1, -1, ENDIANNESS_BIG>;

template class handler_entry_read_dispatch< 2, 2,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 2, 2,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 3, 2,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 3, 2,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 4, 2,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 4, 2,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 5, 2,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 5, 2,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 6, 2,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 6, 2,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 7, 2,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 7, 2,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 8, 2,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 8, 2,  0, ENDIANNESS_BIG>;

template class handler_entry_read_dispatch< 2, 2, -1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 2, 2, -1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 3, 2, -1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 3, 2, -1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 4, 2, -1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 4, 2, -1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 5, 2, -1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 5, 2, -1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 6, 2, -1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 6, 2, -1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 7, 2, -1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 7, 2, -1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 8, 2, -1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 8, 2, -1, ENDIANNESS_BIG>;

template class handler_entry_read_dispatch< 2, 2, -2, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 2, 2, -2, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 3, 2, -2, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 3, 2, -2, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 4, 2, -2, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 4, 2, -2, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 5, 2, -2, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 5, 2, -2, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 6, 2, -2, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 6, 2, -2, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 7, 2, -2, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 7, 2, -2, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 8, 2, -2, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 8, 2, -2, ENDIANNESS_BIG>;

template class handler_entry_read_dispatch< 3, 3,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 3, 3,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 4, 3,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 4, 3,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 5, 3,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 5, 3,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 6, 3,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 6, 3,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 7, 3,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 7, 3,  0, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 8, 3,  0, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 8, 3,  0, ENDIANNESS_BIG>;

template class handler_entry_read_dispatch< 3, 3, -1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 3, 3, -1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 4, 3, -1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 4, 3, -1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 5, 3, -1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 5, 3, -1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 6, 3, -1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 6, 3, -1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 7, 3, -1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 7, 3, -1, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 8, 3, -1, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 8, 3, -1, ENDIANNESS_BIG>;

template class handler_entry_read_dispatch< 3, 3, -2, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 3, 3, -2, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 4, 3, -2, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 4, 3, -2, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 5, 3, -2, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 5, 3, -2, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 6, 3, -2, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 6, 3, -2, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 7, 3, -2, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 7, 3, -2, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 8, 3, -2, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 8, 3, -2, ENDIANNESS_BIG>;

template class handler_entry_read_dispatch< 3, 3, -3, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 3, 3, -3, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 4, 3, -3, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 4, 3, -3, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 5, 3, -3, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 5, 3, -3, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 6, 3, -3, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 6, 3, -3, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 7, 3, -3, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 7, 3, -3, ENDIANNESS_BIG>;
template class handler_entry_read_dispatch< 8, 3, -3, ENDIANNESS_LITTLE>;
template class handler_entry_read_dispatch< 8, 3, -3, ENDIANNESS_BIG>;
